<?php
namespace Teknisa\PLA\Modules\Rfid\Controllers;

use Doctrine\DBAL\Connection;
use Teknisa\Libs\Util\Environment;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Message;

class LogacessoefetUpdateCardadia {

    protected $connection;
    protected $environment;
    protected $updateCardadiaQuery = "UPDATE CARDADIA SET(QTCOMEFETCAR, QTCLIEFETCAR) = ( SELECT comensais, comensais comensaiscliente FROM CARDADIA INNER JOIN (SELECT PLA_PARAMRFID.CDSERVFILI as CDSERVFILI1, PLA_PARAMRFID.CDFILIAL as CDFILIAL1, count(*) as comensais , TRUNC(LOGACESSOEFET.DTREGISTRO) as DTCARDAPIO1 FROM LOGACESSOEFET INNER JOIN PLA_PARAMRFID ON PLA_PARAMRFID.CDLEITOR = LOGACESSOEFET.CDLEITOR AND PLA_PARAMRFID.CDANTENA = LOGACESSOEFET.CDANTENA AND (TO_CHAR(LOGACESSOEFET.DTREGISTRO, 'HH24MI') >= PLA_PARAMRFID.HRINILEITURA AND TO_CHAR(LOGACESSOEFET.DTREGISTRO, 'HH24MI') <= PLA_PARAMRFID.HRFINLEITURA) AND LOGACESSOEFET.NRORG = PLA_PARAMRFID.NRORG WHERE CDETIQUETA LIKE '7ECF00D%' AND LOGACESSOEFET.IDSITUACAO = 'P' AND(LOGACESSOEFET.NRORG = :NRORG) AND PLA_PARAMRFID.CDFILIAL = :CDFILIAL AND((TO_CHAR(LOGACESSOEFET.DTREGISTRO, 'DD/MM/YYYY') BETWEEN :DTREGISTROINI AND :DTREGISTROFIN) OR (:DTREGISTROINI IS NULL AND :DTREGISTROFIN IS NULL)) GROUP BY PLA_PARAMRFID.CDSERVFILI, PLA_PARAMRFID.CDFILIAL, trunc(LOGACESSOEFET.DTREGISTRO)) LOGRFID ON CARDADIA.CDSERVFILI = LOGRFID.CDSERVFILI1 AND CARDADIA.CDFILIAL = LOGRFID.CDFILIAL1 AND CARDADIA.DTCARDAPIO = LOGRFID.DTCARDAPIO1 ) WHERE (CARDADIA.CDSERVFILI, CARDADIA.CDFILIAL, CARDADIA.DTCARDAPIO) IN ( SELECT CARDADIA.CDSERVFILI, CARDADIA.CDFILIAL, CARDADIA.DTCARDAPIO FROM CARDADIA INNER JOIN (SELECT PLA_PARAMRFID.CDSERVFILI as CDSERVFILI1, PLA_PARAMRFID.CDFILIAL as CDFILIAL1, TRUNC(LOGACESSOEFET.DTREGISTRO) as DTCARDAPIO1 FROM LOGACESSOEFET INNER JOIN PLA_PARAMRFID ON PLA_PARAMRFID.CDLEITOR = LOGACESSOEFET.CDLEITOR AND PLA_PARAMRFID.CDANTENA = LOGACESSOEFET.CDANTENA AND (TO_CHAR(LOGACESSOEFET.DTREGISTRO, 'HH24MI') >= PLA_PARAMRFID.HRINILEITURA AND TO_CHAR(LOGACESSOEFET.DTREGISTRO, 'HH24MI') <= PLA_PARAMRFID.HRFINLEITURA) AND LOGACESSOEFET.NRORG = PLA_PARAMRFID.NRORG WHERE CDETIQUETA LIKE '7ECF00D%' AND LOGACESSOEFET.IDSITUACAO = 'P' AND(LOGACESSOEFET.NRORG = :NRORG) AND PLA_PARAMRFID.CDFILIAL = :CDFILIAL AND((TO_CHAR(LOGACESSOEFET.DTREGISTRO, 'DD/MM/YYYY') BETWEEN :DTREGISTROINI AND :DTREGISTROFIN) OR (:DTREGISTROINI IS NULL AND :DTREGISTROFIN IS NULL)) GROUP BY PLA_PARAMRFID.CDSERVFILI, PLA_PARAMRFID.CDFILIAL, trunc(LOGACESSOEFET.DTREGISTRO) ) LOGRFID ON CARDADIA.CDSERVFILI = LOGRFID.CDSERVFILI1 AND CARDADIA.CDFILIAL = LOGRFID.CDFILIAL1 AND CARDADIA.DTCARDAPIO = LOGRFID.DTCARDAPIO1 ) ";
    protected $setStatusCountedLogAcessoEfetQuery = "UPDATE LOGACESSOEFET SET IDSITUACAO = 'C', DTCONTAGEM = SYSDATE WHERE NRSEQLOG IN(SELECT LOGRFID.NRSEQLOG FROM CARDADIA INNER JOIN (SELECT LOGACESSOEFET.NRSEQLOG, PLA_PARAMRFID.CDSERVFILI, PLA_PARAMRFID.CDFILIAL, TRUNC(LOGACESSOEFET.DTREGISTRO) AS DTCARDAPIO FROM LOGACESSOEFET INNER JOIN PLA_PARAMRFID ON PLA_PARAMRFID.CDLEITOR = LOGACESSOEFET.CDLEITOR AND PLA_PARAMRFID.CDANTENA = LOGACESSOEFET.CDANTENA AND (TO_CHAR(LOGACESSOEFET.DTREGISTRO, 'HH24MI') >= PLA_PARAMRFID.HRINILEITURA AND TO_CHAR(LOGACESSOEFET.DTREGISTRO, 'HH24MI') <= PLA_PARAMRFID.HRFINLEITURA) AND LOGACESSOEFET.NRORG = PLA_PARAMRFID.NRORG WHERE CDETIQUETA LIKE '7ECF00D%' AND LOGACESSOEFET.IDSITUACAO = 'P' AND(LOGACESSOEFET.NRORG = :NRORG) AND PLA_PARAMRFID.CDFILIAL = :CDFILIAL AND((TO_CHAR(LOGACESSOEFET.DTREGISTRO, 'DD/MM/YYYY') BETWEEN :DTREGISTROINI AND :DTREGISTROFIN) OR (:DTREGISTROINI IS NULL AND :DTREGISTROFIN IS NULL))) LOGRFID ON CARDADIA.CDSERVFILI = LOGRFID.CDSERVFILI AND CARDADIA.CDFILIAL = LOGRFID.CDFILIAL AND CARDADIA.DTCARDAPIO = LOGRFID.DTCARDAPIO)";
    
    public function __construct(Connection $connection, Environment $environment) {
        $this->connection = $connection;
        $this->environment = $environment;
    }

    public function updateCardadia(DTO\Request $request, DTO\Response $response) {

        $filterCriteria= $request->getFilterCriteria();
        $bindData = $this->toSimpleAssocArray($filterCriteria->getConditions());
        
        
        if (empty($bindData['DTREGISTROINI'])) $bindData['DTREGISTROINI'] = null;
        if (empty($bindData['DTREGISTROFIN'])) $bindData['DTREGISTROFIN'] = null;
        
        if (isset($bindData['HRREGISTROINI'])) unset($bindData['HRREGISTROINI']);
        if (isset($bindData['HRREGISTROFIN'])) unset($bindData['HRREGISTROFIN']);
        
        $bindData['NRORG'] = $this->environment->getNrOrgTrab();
        $bindData['CDFILIAL'] = $this->environment->getCdFilial();
        
        try{
            $this->connection->beginTransaction();
            $query = $this->connection->prepare($this->updateCardadiaQuery);
            $query->execute($bindData);
            $updatedRowsCardadiaCount = $query->rowCount();
            
            $query = $this->connection->prepare($this->setStatusCountedLogAcessoEfetQuery);
            $query->execute($bindData);
            $updatedRowsLogRFIDCount = $query->rowCount();
            $this->connection->commit();
            
            $response->addMessage(new Message("", null, null, array(
                "updatedCardapios" => $updatedRowsCardadiaCount,
                "updatedLogRFID" => $updatedRowsLogRFIDCount
            )));

        } catch(Exception $e) {
            echo 'rip in pieces'. $e.getMessage();
            $response->setError("Algo de muito errado não está certo");
        } 

    }
    
    private function toSimpleAssocArray($zhFilterConditions){
        $newArray = array();
        foreach($zhFilterConditions as $condition){
            $newArray[$condition['columnName']] = $condition['value'];
        }
        return $newArray;
    }

} 